# SoLightModel Class Reference
[Nodes]

`#include <Inventor/nodes/SoLightModel.h>`

Inheritance diagram for SoLightModel:

List of all members.

## Detailed Description

The SoLightModel class is a node for specifying the model for geometry lighting.

Use nodes of this type to set up how lighting should affect subsequent geometry in the scene.

## Public Types

enum | Model { BASE_COLOR = SoLazyElement::BASE_COLOR, PHONG = SoLazyElement::PHONG }

## Public Member Functions

| SoLightModel (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFEnum | model

## Protected Member Functions

virtual | ~SoLightModel ()

## Member Enumeration Documentation

enum SoLightModel::Model

Enumerates available light models.

Enumeration values:

  BASE_COLOR | Use the current diffuse material color for subsequent geometry, and do not let any lightsources influence the appearance of the rendering primitives.
  PHONG | Use Phong-style shading for the geometry.

## Constructor & Destructor Documentation

SoLightModel::SoLightModel | ( | void |  | ) |

| Constructor.

SoLightModel::~SoLightModel | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoLightModel::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoLightModel::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoLightModel::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoLightModel::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

## Member Data Documentation

SoSFEnum SoLightModel::model

| Lightmodel to use. Defaults to SoLightModel::PHONG.

The documentation for this class was generated from the following files:

- SoLightModel.h
- SoLightModel.cpp